diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/tap-bridge/bindings/modulegen__gcc_LP64.py ns-3.32/src/tap-bridge/bindings/modulegen__gcc_LP64.py
--- ns-3.31/src/tap-bridge/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/tap-bridge/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
@@ -4499,7 +4602,7 @@
     cls.add_method('operator()', 
                    'bool', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4521,7 +4624,7 @@
     cls.add_method('operator()', 
                    'bool', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3')], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Ns3ObjectBase___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4543,7 +4646,7 @@
     cls.add_method('operator()', 
                    'ns3::ObjectBase *', 
                    [], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4565,7 +4668,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4587,7 +4690,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0')], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4609,7 +4712,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Unsigned_char___star___Long_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4631,7 +4734,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('unsigned char *', 'arg0'), param('long int', 'arg1')], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/tap-bridge/examples/tap-wifi-virtual-machine.cc ns-3.32/src/tap-bridge/examples/tap-wifi-virtual-machine.cc
--- ns-3.31/src/tap-bridge/examples/tap-wifi-virtual-machine.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/tap-bridge/examples/tap-wifi-virtual-machine.cc	2020-10-06 15:35:43.000000000 -0700
@@ -105,7 +105,7 @@
   // We're going to use 802.11 A so set up a wifi helper to reflect that.
   //
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_PHY_STANDARD_80211a);
+  wifi.SetStandard (WIFI_STANDARD_80211a);
   wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager", "DataMode", StringValue ("OfdmRate54Mbps"));
 
   //
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/tap-bridge/examples/tap-wifi-virtual-machine.py ns-3.32/src/tap-bridge/examples/tap-wifi-virtual-machine.py
--- ns-3.31/src/tap-bridge/examples/tap-wifi-virtual-machine.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/tap-bridge/examples/tap-wifi-virtual-machine.py	2020-10-06 15:35:43.000000000 -0700
@@ -48,7 +48,7 @@
     # We're going to use 802.11 A so set up a wifi helper to reflect that.
     #
     wifi = ns.wifi.WifiHelper()
-    wifi.SetStandard (ns.wifi.WIFI_PHY_STANDARD_80211a);
+    wifi.SetStandard (ns.wifi.WIFI_STANDARD_80211a);
     wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager", "DataMode", ns.core.StringValue ("OfdmRate54Mbps"));
 
     #
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/tap-bridge/model/tap-bridge.cc ns-3.32/src/tap-bridge/model/tap-bridge.cc
--- ns-3.31/src/tap-bridge/model/tap-bridge.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/tap-bridge/model/tap-bridge.cc	2020-10-06 15:35:43.000000000 -0700
@@ -52,7 +52,7 @@
 
 FdReader::Data TapBridgeFdReader::DoRead (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   uint32_t bufferSize = 65536;
   uint8_t *buf = (uint8_t *)std::malloc (bufferSize);
@@ -132,6 +132,11 @@
                    MakeEnumChecker (CONFIGURE_LOCAL, "ConfigureLocal",
                                     USE_LOCAL, "UseLocal",
                                     USE_BRIDGE, "UseBridge"))
+    .AddAttribute ("Verbose",
+                   "Enable verbose output from tap-creator child process",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&TapBridge::m_verbose),
+                   MakeBooleanChecker ())
   ;
   return tid;
 }
@@ -145,14 +150,14 @@
     m_fdReader (0),
     m_ns3AddressRewritten (false)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_packetBuffer = new uint8_t[65536];
   Start (m_tStart);
 }
 
 TapBridge::~TapBridge()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   StopTapDevice ();
 
@@ -165,14 +170,14 @@
 void
 TapBridge::DoDispose ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   NetDevice::DoDispose ();
 }
 
 void
 TapBridge::Start (Time tStart)
 {
-  NS_LOG_FUNCTION (tStart);
+  NS_LOG_FUNCTION (this << tStart);
 
   //
   // Cancel any pending start event and schedule a new one at some relative time in the future.
@@ -184,7 +189,7 @@
 void
 TapBridge::Stop (Time tStop)
 {
-  NS_LOG_FUNCTION (tStop);
+  NS_LOG_FUNCTION (this << tStop);
   //
   // Cancel any pending stop event and schedule a new one at some relative time in the future.
   //
@@ -195,7 +200,7 @@
 void
 TapBridge::StartTapDevice (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   NS_ABORT_MSG_IF (m_sock != -1, "TapBridge::StartTapDevice(): Tap is already started");
 
@@ -237,7 +242,7 @@
 void
 TapBridge::StopTapDevice (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   if (m_fdReader != 0)
     {
@@ -255,7 +260,7 @@
 void
 TapBridge::CreateTap (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   // 
   // The TapBridge has three distinct operating modes.  At this point, the
@@ -488,13 +493,31 @@
           ossMode << "3";
         }
 
+      std::ostringstream ossVerbose;
+      if (m_verbose)
+        {
+          ossVerbose << "-v";
+        }
+
       std::ostringstream ossPath;
       ossPath << "-p" << path;
+
+      NS_LOG_DEBUG ("Executing: " << TAP_CREATOR <<
+                    " " << ossDeviceName.str () <<
+                    " " << ossGateway.str () <<
+                    " " << ossIp.str () <<
+                    " " << ossMac.str () <<
+                    " " << ossNetmask.str () <<
+                    " " << ossMode.str () <<
+                    " " << ossPath.str () <<
+                    " " << ossVerbose.str ()
+                   );
+
       //
       // Execute the socket creation process image.
       //
       status = ::execlp (TAP_CREATOR, 
-                         TAP_CREATOR,                       // argv[0] (filename)
+                         TAP_CREATOR,                         // argv[0] (filename)
                          ossDeviceName.str ().c_str (),       // argv[1] (-d<device name>)
                          ossGateway.str ().c_str (),          // argv[2] (-g<gateway>)
                          ossIp.str ().c_str (),               // argv[3] (-i<IP address>)
@@ -502,6 +525,7 @@
                          ossNetmask.str ().c_str (),          // argv[5] (-n<net mask>)
                          ossMode.str ().c_str (),             // argv[6] (-o<operating mode>)
                          ossPath.str ().c_str (),             // argv[7] (-p<path>)
+                         ossVerbose.str ().c_str (),          // argv[8] (-v)
                          (char *)NULL);
 
       //
@@ -534,6 +558,10 @@
           NS_ABORT_MSG_IF (exitStatus != 0, 
                            "TapBridge::CreateTap(): socket creator exited normally with status " << exitStatus);
         }
+      else if (WIFSIGNALED (st))
+        {
+          NS_FATAL_ERROR ("TapBridge::CreateTap(): socket creator exited with signal " << WTERMSIG (st));
+        }
       else 
         {
           NS_FATAL_ERROR ("TapBridge::CreateTap(): socket creator exited abnormally");
@@ -667,7 +695,7 @@
 void
 TapBridge::ReadCallback (uint8_t *buf, ssize_t len)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << buf << len);
 
   NS_ASSERT_MSG (buf != 0, "invalid buf argument");
   NS_ASSERT_MSG (len > 0, "invalid len argument");
@@ -692,7 +720,7 @@
 void
 TapBridge::ForwardToBridgedDevice (uint8_t *buf, ssize_t len)
 {
-  NS_LOG_FUNCTION (buf << len);
+  NS_LOG_FUNCTION (this << buf << len);
 
   //
   // There are three operating modes for the TapBridge
@@ -819,7 +847,7 @@
 Ptr<Packet>
 TapBridge::Filter (Ptr<Packet> p, Address *src, Address *dst, uint16_t *type)
 {
-  NS_LOG_FUNCTION (p);
+  NS_LOG_FUNCTION (this << p);
   uint32_t pktSize;
 
   //
@@ -881,14 +909,14 @@
 Ptr<NetDevice>
 TapBridge::GetBridgedNetDevice (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_bridgedDevice;
 }
 
 void 
 TapBridge::SetBridgedNetDevice (Ptr<NetDevice> bridgedDevice)
 {
-  NS_LOG_FUNCTION (bridgedDevice);
+  NS_LOG_FUNCTION (this << bridgedDevice);
 
   NS_ASSERT_MSG (m_node != 0, "TapBridge::SetBridgedDevice:  Bridge not installed in a node");
   NS_ASSERT_MSG (bridgedDevice != this, "TapBridge::SetBridgedDevice:  Cannot bridge to self");
@@ -921,7 +949,7 @@
 bool
 TapBridge::DiscardFromBridgedDevice (Ptr<NetDevice> device, Ptr<const Packet> packet, uint16_t protocol, const Address &src)
 {
-  NS_LOG_FUNCTION (device << packet << protocol << src);
+  NS_LOG_FUNCTION (this << device << packet << protocol << src);
   NS_LOG_LOGIC ("Discarding packet stolen from bridged device " << device);
   return true;
 }
@@ -935,7 +963,7 @@
   const Address &dst, 
   PacketType packetType)
 {
-  NS_LOG_FUNCTION (device << packet << protocol << src << dst << packetType);
+  NS_LOG_FUNCTION (this << device << packet << protocol << src << dst << packetType);
   NS_ASSERT_MSG (device == m_bridgedDevice, "TapBridge::SetBridgedDevice:  Received packet from unexpected device");
   NS_LOG_DEBUG ("Packet UID is " << packet->GetUid ());
 
@@ -1001,56 +1029,56 @@
 void 
 TapBridge::SetIfIndex (const uint32_t index)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << index);
   m_ifIndex = index;
 }
 
 uint32_t 
 TapBridge::GetIfIndex (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_ifIndex;
 }
 
 Ptr<Channel> 
 TapBridge::GetChannel (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return 0;
 }
 
 void
 TapBridge::SetAddress (Address address)
 {
-  NS_LOG_FUNCTION (address);
+  NS_LOG_FUNCTION (this << address);
   m_address = Mac48Address::ConvertFrom (address);
 }
 
 Address 
 TapBridge::GetAddress (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_address;
 }
 
 void
 TapBridge::SetMode (enum Mode mode)
 {
-  NS_LOG_FUNCTION (mode);
+  NS_LOG_FUNCTION (this << mode);
   m_mode = mode;
 }
 
 TapBridge::Mode
 TapBridge::GetMode (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_mode;
 }
 
 bool 
 TapBridge::SetMtu (const uint16_t mtu)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << mtu);
   m_mtu = mtu;
   return true;
 }
@@ -1058,14 +1086,14 @@
 uint16_t 
 TapBridge::GetMtu (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_mtu;
 }
 
 void
 TapBridge::NotifyLinkUp (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (!m_linkUp)
     {
       m_linkUp = true;
@@ -1076,35 +1104,35 @@
 bool 
 TapBridge::IsLinkUp (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_linkUp;
 }
 
 void 
 TapBridge::AddLinkChangeCallback (Callback<void> callback)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_linkChangeCallbacks.ConnectWithoutContext (callback);
 }
 
 bool 
 TapBridge::IsBroadcast (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return true;
 }
 
 Address
 TapBridge::GetBroadcast (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return Mac48Address ("ff:ff:ff:ff:ff:ff");
 }
 
 bool
 TapBridge::IsMulticast (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return true;
 }
 
@@ -1119,14 +1147,14 @@
 bool 
 TapBridge::IsPointToPoint (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return false;
 }
 
 bool 
 TapBridge::IsBridge (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   //
   // Returning false from IsBridge in a device called TapBridge may seem odd
   // at first glance, but this test is for a device that bridges ns-3 devices
@@ -1139,7 +1167,7 @@
 bool 
 TapBridge::Send (Ptr<Packet> packet, const Address& dst, uint16_t protocol)
 {
-  NS_LOG_FUNCTION (packet << dst << protocol);
+  NS_LOG_FUNCTION (this << packet << dst << protocol);
   NS_FATAL_ERROR ("TapBridge::Send: You may not call Send on a TapBridge directly");
   return false;
 }
@@ -1147,7 +1175,7 @@
 bool 
 TapBridge::SendFrom (Ptr<Packet> packet, const Address& src, const Address& dst, uint16_t protocol)
 {
-  NS_LOG_FUNCTION (packet << src << dst << protocol);
+  NS_LOG_FUNCTION (this << packet << src << dst << protocol);
   NS_FATAL_ERROR ("TapBridge::Send: You may not call SendFrom on a TapBridge directly");
   return false;
 }
@@ -1155,42 +1183,42 @@
 Ptr<Node> 
 TapBridge::GetNode (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_node;
 }
 
 void 
 TapBridge::SetNode (Ptr<Node> node)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_node = node;
 }
 
 bool 
 TapBridge::NeedsArp (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return true;
 }
 
 void 
 TapBridge::SetReceiveCallback (NetDevice::ReceiveCallback cb)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_rxCallback = cb;
 }
 
 void 
 TapBridge::SetPromiscReceiveCallback (NetDevice::PromiscReceiveCallback cb)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_promiscRxCallback = cb;
 }
 
 bool
 TapBridge::SupportsSendFrom () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return true;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/tap-bridge/model/tap-bridge.h ns-3.32/src/tap-bridge/model/tap-bridge.h
--- ns-3.31/src/tap-bridge/model/tap-bridge.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/tap-bridge/model/tap-bridge.h	2020-10-06 15:35:43.000000000 -0700
@@ -451,6 +451,13 @@
   bool m_linkUp;
 
   /**
+   * Flag indicating whether or not the link is up.  In this case,
+   * whether or not ns-3 is connected to the underlying TAP device
+   * with a file descriptor.
+   */
+  bool m_verbose;
+
+  /**
    * Callbacks to fire if the link changes state (up or down).
    */
   TracedCallback<> m_linkChangeCallbacks;
